
;DMACONR		EQU		$dff002
;ADKCONR		EQU		$dff010
;INTENAR		EQU		$dff01c
;INTREQR		EQU		$dff01e

DMACON		EQU		$dff096
;ADKCON		EQU		$dff09e
INTENA		EQU		$dff09a
;INTREQ		EQU		$dff09c

BPLCON0         EQU             $dff100
BPLCON1         EQU             $dff102
BPL1MOD         EQU             $dff108
BPL2MOD         EQU             $dff10a
DIWSTRT         EQU             $dff08e
DIWSTOP         EQU             $dff090
DDFSTRT         EQU             $dff092
DDFSTOP         EQU             $dff094
;VPOSR           EQU             $dff004
COP1LCH         EQU             $dff080
;CIAAPRA         EQU             $bfe001


AmigaInit:
	move.l	$4,a6
	move.l	#gfxname,a1
	moveq.l	#0,d0
	jsr	(-552,a6)	;Exec - Openlibrary
	move.l	d0,gfxbase
	move.l 	d0,a6

	 move.l #0,a1
	 jsr -222(a6)	; LoadView - Use a (possibly freshly created) coprocessor instruction list to create the current display.
	; jsr -270(a6)	; WaitTOF - Wait for the top of the next video frame.
	; jsr -270(a6)	; WaitTOF
	; move.l	$4,a6
	; jsr -132(a6)	; Forbid

	
; 		      FEDCBA9876543210
; 			  RPPPHDCG----PIE-	 		;four bitPlanes Color on
	move.w	#%0100001000000000,BPLCON0	;Bitplane control register (misc. control bits)
	
	move.w	#$0000,BPLCON1			; horizontal scroll 0 - Bitplane control reg. (scroll value PF1, PF2)
	move.w	#$0000,BPL1MOD			; Bitplane modulo (odd planes)
	move.w	#$0000,BPL2MOD			; Bitplane modulo (even planes)
	move.w	#$2c81,DIWSTRT			; Display window start (upper left vert-horiz position)
	move.w	#$F4C1,DIWSTOP			; Display window stop (lower right vert.-horiz. Position)
	move.w	#$0038,DDFSTRT			; Display bitplane data fetch start (horiz. Position)
	move.w	#$00d0,DDFSTOP			; Display bitplane data fetch stop (horiz. position)
		  	; FEDCBA9876543210
	move.w  #%1000000110000000,DMACON   ; DMA set ON  - DMA control (and blitter status) read (Bit 15 defines set/clear for other bits)
	move.w 	#%0000000001111111,DMACON	; DMA set OFF - turn off sound
	move.w 	#%1100000000000000,INTENA	; IRQ set ON  - Interrupt enable bits read - Turn on master
	move.w 	#%0011111111111111,INTENA	; IRQ set OFF - Turn off all others

	lea CopperList,a6					;Copperlist (Commands run by Copper Coprocessor)
   
	move.l #Screen_Mem+(40*200*0),d0	; bitplane 0
	move.w #$00e2,(a6)+					; Bitplane AddressL
	move.w d0,(a6)+		
	swap d0
	move.w #$00e0,(a6)+					; Bitplane AddressH
	move.w d0,(a6)+		
	
	move.l #Screen_Mem+(40*200*1),d0	; bitplane 1
	move.w #$00e6,(a6)+					; Bitplane AddressL
	move.w d0,(a6)+		
	swap d0
	move.w #$00e4,(a6)+					; Bitplane AddressH
	move.w d0,(a6)+		

	move.l #Screen_Mem+(40*200*2),d0	; bitplane 2
	move.w #$00ea,(a6)+					; Bitplane AddressL
	move.w d0,(a6)+		
	swap d0
	move.w #$00e8,(a6)+					; Bitplane AddressH
	move.w d0,(a6)+		
	
	move.l #Screen_Mem+(40*200*3),d0	; bitplane 3
	move.w #$00eE,(a6)+					; Bitplane AddressL
	move.w d0,(a6)+		
	swap d0
	move.w #$00eC,(a6)+					; Bitplane AddressH
	move.w d0,(a6)+		


	lea PalettePointer,a1		;Load the address of the palette data in
	move.l a6,(a1)				;   the copperlist into our pointer for easy changing
	       ; AAAA-RGB			;Address - RGB
	move.l #$01800005,(a6)+		; color 0
	move.l #$01820FF0,(a6)+		; color 1
	move.l #$018400FF,(a6)+		; color 2
	move.l #$01860F00,(a6)+		; color 3
	move.l #$01880f53,(a6)+		; color 4
	move.l #$018a07ad,(a6)+		; color 5
	move.l #$018c0000,(a6)+		; color 6
	move.l #$018e0cef,(a6)+		; color 7
	move.l #$01900005,(a6)+		; color 8
	move.l #$01920FF0,(a6)+		; color 9
	move.l #$019400FF,(a6)+		; color A
	move.l #$01960F00,(a6)+		; color B
	move.l #$01980f53,(a6)+		; color C
	move.l #$019a07ad,(a6)+		; color D
	move.l #$019c0000,(a6)+		; color E
	move.l #$019e0FF0,(a6)+		; color F
	
	move.l #$fffffffe,(a6)+		; end of copperlist

	jsr waitVBlank
	
	lea CopperList,a6	;Enable the CopperList
	move.l a6,COP1LCH 	;Coprocessor first location register (high 3 bits, high 5 bits if ECS)
			 ;COP1LCL	;Coprocessor first location register (low 15 bits)

	clr.b (Cursor_X)
	clr.b (Cursor_Y)