KeyboardScanner_AllowJoysticks:
	move.w	#$14,-(sp)	;IKBD command $14 - set joystick event reporting
	move.w	#4,-(sp)	;Device no 4 (keyboard - Joystick is part of keyboard)
	move.w	#3,-(sp)	;Bconout (send cmd to keyboard)
	trap	#13			;BIOS Trap
	addq.l 	#6,sp		;Fix the stack

	move.w  #34,-(sp)	;return IKBD vector table (KBDVBASE)
	trap  	#14			;XBIOS trap
	addq.l  #2,sp 		;Fix the stack
	
	move.l  d0,ikbd_vec 	; store IKBD vectors address for later
	move.l  d0,a0  			; A0 points to IKBD vectors
	move.l  24(a0),old_joy 	; backup old joystick vector so we can restore it
	move.l  #JoystickHandler,24(a0); Set our Joystick Handler
	rts
	
JoystickHandler
	move.b  (1,a0),joydata  		; store joy 0 data
	move.b  (2,a0),joydata+1 	; store joy 1 data
	rts  

ikbd_vec:	dc.l 0 			; old IKBD vector storage
old_joy:	dc.l 0    		; old joy vector storage
joydata:	ds.b 2			;Joypad bytes F----RLDU 


Player_ReadControlsDual:;---7654S321RLDU
	move.l #$FFFFFFFF,d1
	move.l d1,d0
	move.b (joydata),d1
	roxl.b #1,d1
	rol.b #3,d1
	roxr.b #1,d1
	roxr.b #3,d1
	eor.b #$FF,d1
	
	move.b (joydata+1),d0
	roxl.b #1,d0
	rol.b #3,d0
	roxr.b #1,d0
	roxr.b #3,d0
	eor.b #$FF,d0
	
	
	rts
	
	
;	H.4.2 Joystick Interrogation
;The current state of the joystick ports may be interrogated at any time in this mode by
;sending an 'Interrogate Joystick' command to the ikbd.
;The ikbd response to joystick interrogation is a three byte report of the form
;0xFD  ; joystick report header
;%x000yyyy  ; Joystick 0
;%x000yyyy  ; Joystick 1
;; where x is the trigger
;; and yyy is the stick position



;move.l  #joy_on,-(sp)  pointer to IKBD instructions
;move.w  #0,-(sp)  instruction length - 1
;move.w  #25,-(sp)  send instruction to IKBD
;trap  #14
;addq.l  #8,sp
;joy_on:  dc.b  $14