
DefineTiles:
	jsr prepareVram
;		move.l d2,(VDP_ctrl)
DefineTilesAgain:
		move.l (a0)+,d0
		move.l d0,(VDP_data)
		
		dbra.w d1,DefineTilesAgain
		
	rts
	
prepareVram:		;7FFF003 = FFFF 40000=0000
	moveM.l d0-d7/a0-a7,-(sp)
		move.l d2,d0
		and.w #%1100000000000000,d0
		rol.w #2,d0
		and.l #%0011111111111111,d2
		rol.l #8,d2
		rol.l #8,d2
		;rol.l #2,d2
		or.l d0,d2
		or.l #$40000000,d2
		;jsr Monitor
		move.l d2,(VDP_ctrl)
	moveM.l (sp)+,d0-d7/a0-a7
	rts

	
FillAreaWithTiles:

	;move.l #3,d0	;SX
	;move.l #3,d1	;SY
	
	;move.l #6,d2	;WID
	;move.l #6,d3	;HEI
	
	;move.l #256,d4	;TileStart

	
	moveM.l d0-d7/a0-a7,-(sp)
	clr.l d6
	clr.l d7
	
	subq.l #1,d3
	subq.l #1,d2
	
	
	move.l #256,d4	;TileStart
	
NextTileLine:
	move.l d0,-(sp)	;SX
	move.l d2,-(sp)
NextTileb:
	
	
		;move.l d4,-(sp)
			Move.L  #$40000003,d5
			Move.L #0,d7
			Move.B d1,D7	;Y
			
			rol.L #8,D7
			rol.L #8,D7
			rol.L #7,D7
			
			add.L D7,D5
			
			Move.B d0,D7	;X
			rol.L #8,D7
			rol.L #8,D7
			rol.L #1,D7
			add.L D7,D5
		;move.l (sp)+,d4	
		MOVE.L	D5,(VDP_ctrl)			; C00004 write next character to VDP
		MOVE.W	D4,(VDP_data)			; C00000 store next word of name data
			
		addq.W #1,D0
		addq.w #1,d4
		
	dbra.w d2,NextTileb
	add.w #1,d1
	move.l (sp)+,d2
	move.l (sp)+,d0
	dbra.w d3,NextTileLine

	moveM.l (sp)+,d0-d7/a0-a7
	rts
	
	
	
	
	
waitVBlank:
	move.w VDP_ctrl,d0
	and.w #%0000000000001000,d0		;See if vblank is running
	beq waitVBlank			;wait until it isnt
		
waitVBlank2:
	
	move.w VDP_ctrl,d0
	and.w #%0000000000001000,d0		;See if vblank is running
	bne waitVBlank2			;wait until it is
	rts


ScreenINIT:	
	LEA	VDPSettings,A5			;initialize registers
	MOVE.W	(VDP_ctrl),D0		;C00004 read VDP status (interrupt acknowledge?)

	move.l #$00008000,d5		;VDP Reg command
	MOVEQ.l	#24-1,D1			;length of video initialization block
NextInitByte:
	MOVE.B	(A5)+,D5			;get next video control byte
	MOVE.W	D5,(VDP_ctrl)		;C00004 send write register command to VDP
	ADD.W	#$00000100,D5		;point to next VDP register
	DBRA	D1,NextInitByte		;loop for rest of block


	;Define palette
	move.l #$C0000000,d0					;Color 0
	move.l d0,VDP_Ctrl
	;        ----BBB-GGG-RRR-
	move.w #%0000011000000000,VDP_data
	
	move.l #$C0020000,d0					;Color 1
	move.l d0,VDP_Ctrl
	move.w #%0000000011101110,VDP_data
	
	move.l #$C0040000,d0					;Color 2
	move.l d0,VDP_Ctrl
	move.w #%0000111011100000,VDP_data
	
	move.l #$C0060000,d0					;Color 3
	move.l d0,VDP_Ctrl
	move.w #%0000000000001110,VDP_data
	
	move.l #$C01E0000,d0					;Color 15
	move.l d0,VDP_Ctrl
	move.w #%0000000011101110,VDP_data
	
	MOVE.W	#$8144,(VDP_Ctrl)				; C00004 reg 1 = 0x44 unblank display
	
	jmp FontINIT
	
	EVEN


VDPSettings:
		DC.B $04 ; 0 mode register 1											---H-1M-
		DC.B $04 ; 1 mode register 2											-DVdP---
		DC.B $30 ; 2 name table base for scroll A (A=top 3 bits)				--AAA--- = $C000
		DC.B $3C ; 3 name table base for window (A=top 4 bits / 5 in H40 Mode)	--AAAAA- = $F000
		DC.B $07 ; 4 name table base for scroll B (A=top 3 bits)				-----AAA = $E000
		DC.B $6C ; 5 sprite attribute table base (A=top 7 bits / 6 in H40)		-AAAAAAA = $D800
		DC.B $00 ; 6 unused register											--------
		DC.B $00 ; 7 background color (P=Palette C=Color)						--PPCCCC
		DC.B $00 ; 8 unused register											--------
		DC.B $00 ; 9 unused register											--------
		DC.B $FF ;10 H interrupt register (L=Number of lines)					LLLLLLLL
		DC.B $00 ;11 mode register 3											----IVHL
		DC.B $81 ;12 mode register 4 (C bits both1 = H40 Cell)					C---SIIC
		DC.B $37 ;13 H scroll table base (A=Top 6 bits)							--AAAAAA = $FC00
		DC.B $00 ;14 unused register											--------
		DC.B $02 ;15 auto increment (After each Read/Write)						NNNNNNNN
		DC.B $01 ;16 scroll size (Horiz & Vert size of ScrollA & B)				--VV--HH
		DC.B $00 ;17 window H position (D=Direction C=Cells)					D--CCCCC
		DC.B $00 ;18 window V position (D=Direction C=Cells)					D--CCCCC
		DC.B $FF ;19 DMA length count low										LLLLLLLL
		DC.B $FF ;20 DMA length count high										HHHHHHHH
		DC.B $00 ;21 DMA source address low										LLLLLLLL
		DC.B $00 ;22 DMA source address mid										MMMMMMMM
		DC.B $80 ;23 DMA source address high (C=CMD)							CCHHHHHH


	even