
DMACONR		EQU		$dff002
ADKCONR		EQU		$dff010
INTENAR		EQU		$dff01c
INTREQR		EQU		$dff01e

DMACON		EQU		$dff096
ADKCON		EQU		$dff09e
INTENA		EQU		$dff09a
INTREQ		EQU		$dff09c

BPLCON0         EQU             $dff100
BPLCON1         EQU             $dff102
BPL1MOD         EQU             $dff108
BPL2MOD         EQU             $dff10a
DIWSTRT         EQU             $dff08e
DIWSTOP         EQU             $dff090
DDFSTRT         EQU             $dff092
DDFSTOP         EQU             $dff094
VPOSR           EQU             $dff004
COP1LCH         EQU             $dff080

CIAAPRA         EQU             $bfe001


init:
	; store data in hardwareregisters ORed with $8000
        ;(bit 15 is a write-set bit when values are written back into the system)
	; move.w	DMACONR,d0
	; or.w #$8000,d0
	; move.w d0,olddmareq
	; move.w	INTENAR,d0
	; or.w #$8000,d0
	; move.w d0,oldintena
	; move.w	INTREQR,d0
	; or.w #$8000,d0
	; move.w d0,oldintreq
	; move.w	ADKCONR,d0
	; or.w #$8000,d0
	; move.w d0,oldadkcon

	move.l	$4,a6
	move.l	#gfxname,a1
	moveq	#0,d0
	jsr	-552(a6)
	move.l	d0,gfxbase
	move.l 	d0,a6
	;move.l 	34(a6),oldview
	;move.l 	38(a6),oldcopper

	move.l #0,a1
	jsr -222(a6)	; LoadView
	jsr -270(a6)	; WaitTOF
	jsr -270(a6)	; WaitTOF
	move.l	$4,a6
	jsr -132(a6)	; Forbid

        ; setup displayhardware to show a 320x200px 3 bitplanes playfield
        ; with zero horizontal scroll and zero modulos
; 		      FEDCBA9876543210
;			  RPPPHDCG ----PIE-	
	move.w	#%0100001000000000,BPLCON0			; four bitplanes  RPPPHDCG ----PIE-	
	;move.w	#$3200,BPLCON0			; three bitplanes
	move.w	#$0000,BPLCON1			; horizontal scroll 0
	move.w	#$0000,BPL1MOD			; odd modulo
	move.w	#$0000,BPL2MOD			; even modulo
	move.w	#$2c81,DIWSTRT			; DIWSTRT - topleft corner (2c81)
	move.w	#$F4C1,DIWSTOP			; DIWSTOP - bottomright corner (c8d1)
	move.w	#$0038,DDFSTRT			; DDFSTRT
	move.w	#$00d0,DDFSTOP			; DDFSTOP
		  	; FEDCBA9876543210
	move.w  #%1000000110000000,DMACON       ; DMA set ON
	move.w 	#%0000000001111111,DMACON	; DMA set OFF
	move.w 	#%1100000000000000,INTENA	; IRQ set ON
	move.w 	#%0011111111111111,INTENA	; IRQ set OFF

mainloop:
        ;move.l frame,d1
	move.l #copper,a6
    ;    addq.l #1,d1
        ;move.l d1,frame

	; bitplane 0
	move.l #bitplanes+(40*200*0),d0
	move.w #$00e2,(a6)+	; LO-bits of start of bitplane
	move.w d0,(a6)+		; go into $dff0e2
	swap d0
	move.w #$00e0,(a6)+	; HI-bits of start of bitplane
	move.w d0,(a6)+		; go into $dff0e0

	; bitplane 1
	move.l #bitplanes+(40*200*1),d0
	move.w #$00e6,(a6)+	; LO-bits of start of bitplane
	move.w d0,(a6)+		; go into $dff0e6
	swap d0
	move.w #$00e4,(a6)+	; HI-bits of start of bitplane
	move.w d0,(a6)+		; go into $dff0e4

	; bitplane 2
	move.l #bitplanes+(40*200*2),d0
	move.w #$00ea,(a6)+	; LO-bits of start of bitplane
	move.w d0,(a6)+		; go into $dff0e6
	swap d0
	move.w #$00e8,(a6)+	; HI-bits of start of bitplane
	move.w d0,(a6)+		; go into $dff0e4
	
	; bitplane 3
	move.l #bitplanes+(40*200*3),d0
	move.w #$00eE,(a6)+	; LO-bits of start of bitplane
	move.w d0,(a6)+		; go into $dff0e6
	swap d0
	move.w #$00eC,(a6)+	; HI-bits of start of bitplane
	move.w d0,(a6)+		; go into $dff0e4


	; colors
	;             RGB
	lea PalettePointer,a1
	move.l a6,(a1)
	
	move.l #$01800005,(a6)+	; color 0
	move.l #$01820FF0,(a6)+	; color 1
	move.l #$018400FF,(a6)+	; color 2
	move.l #$01860F00,(a6)+	; color 3
	move.l #$01880f53,(a6)+	; color 4
	move.l #$018a07ad,(a6)+	; color 5
	move.l #$018c0000,(a6)+	; color 6
	move.l #$018e0cef,(a6)+	; color 7
	move.l #$01900005,(a6)+	; color 8
	move.l #$01920FF0,(a6)+	; color 9
	move.l #$019400FF,(a6)+	; color A
	move.l #$01960F00,(a6)+	; color B
	move.l #$01980f53,(a6)+	; color C
	move.l #$019a07ad,(a6)+	; color D
	move.l #$019c0000,(a6)+	; color E
	move.l #$019e0FF0,(a6)+	; color F
	; end of copperlist
	move.l #$fffffffe,(a6)+

	; if mousebutton/joystick 1 or 2 pressed then exit
	;btst.b #6,CIAAPRA
	;beq exit
	;btst.b #7,CIAAPRA
	;beq exit

	
; Wait for vertical blanking before taking the copper list into use
waitVB:
	move.l VPOSR,d0
	and.l #$1ff00,d0
	cmp.l #300<<8,d0
	bne waitVB

	; Take copper list into use
	move.l #copper,a6
	move.l a6,COP1LCH
	
	move.b #0,(Cursor_X)
	move.b #0,(Cursor_Y)